package cn.com.qmth.stmms.ms.core.domain;

import cn.com.qmth.stmms.ms.core.domain.user.Role;
import cn.com.qmth.stmms.ms.core.vo.Subject;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.Date;

/**
 * @Description: 操作日志 entity
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2019/10/19
 */
@Entity
@Table(name = "mark_log")
@DynamicInsert
@DynamicUpdate
public class MarkLog implements Serializable {

    private static final long serialVersionUID = -8376036816154911286L;

    private Long id;
    @NotNull
    private Long createUserId;
    @NotNull
    private String createUserName;
    @NotNull
    private String createRole;
    private String subject;
    @NotNull
    private String examNumber;
    @NotNull
    private String studentName;
    @NotNull
    @Enumerated(value = EnumType.STRING)
    private Integer operType;
    private String operDataBefore;
    private String operDataAfter;
    @Temporal(value = TemporalType.DATE)
    @NotNull
    private Date createTime;
    @NotNull
    private Long workId;
    @NotNull
    private Long paperId;
    private String remark;
    @NotNull
    @Enumerated(value = EnumType.ORDINAL)
    private MarkStage stage;

    public MarkLog() {

    }

    public MarkLog(Long createUserId, String createUserName, Role createRole,
                   Subject subject, String examNumber, String studentName,
                   Integer operType, Long workId, Long paperId, MarkStage stage, String operDataBefore, String operDataAfter, String remark) {
        this.createUserId = createUserId;
        this.createUserName = createUserName;
        this.createRole = createRole.getName();
        this.subject = subject.toString();
        this.examNumber = examNumber;
        this.studentName = studentName;
        this.operType = operType;
        this.workId = workId;
        this.paperId = paperId;
        this.stage = stage;
        this.operDataAfter = operDataAfter;
        this.operDataBefore = operDataBefore;
        this.remark = remark;
        this.createTime = new Date();
    }

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public MarkStage getStage() {
        return stage;
    }

    public void setStage(MarkStage stage) {
        this.stage = stage;
    }

    @Id
    @GeneratedValue
    @Column(name = "id")
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Basic
    @Column(name = "create_user_id")
    public Long getCreateUserId() {
        return createUserId;
    }

    public void setCreateUserId(Long createUserId) {
        this.createUserId = createUserId;
    }

    @Basic
    @Column(name = "create_user_name")
    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    @Basic
    @Column(name = "create_role")
    public String getCreateRole() {
        return createRole;
    }

    public void setCreateRole(String createRole) {
        this.createRole = createRole;
    }

    @Basic
    @Column(name = "subject")
    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    @Basic
    @Column(name = "exam_number")
    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    @Basic
    @Column(name = "student_name")
    public String getStudentName() {
        return studentName;
    }

    public void setStudentName(String studentName) {
        this.studentName = studentName;
    }

    @Basic
    @Column(name = "oper_type")
    public Integer getOperType() {
        return operType;
    }

    public void setOperType(Integer operType) {
        this.operType = operType;
    }

    @Basic
    @Column(name = "oper_data_before")
    public String getOperDataBefore() {
        return operDataBefore;
    }

    public void setOperDataBefore(String operDataBefore) {
        this.operDataBefore = operDataBefore;
    }

    @Basic
    @Column(name = "oper_data_after")
    public String getOperDataAfter() {
        return operDataAfter;
    }

    public void setOperDataAfter(String operDataAfter) {
        this.operDataAfter = operDataAfter;
    }

    @Basic
    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Basic
    @Column(name = "work_id")
    public Long getWorkId() {
        return workId;
    }

    public void setWorkId(Long workId) {
        this.workId = workId;
    }

    @Basic
    @Column(name = "paper_id")
    public Long getPaperId() {
        return paperId;
    }

    public void setPaperId(Long paperId) {
        this.paperId = paperId;
    }

    @Basic
    @Column(name = "remark")
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }
}
